From bc9d949dbc70bd19c24161f64d8c941b8bb18376 Mon Sep 17 00:00:00 2001
From: Kalle Valo <kvalo@codeaurora.org>
Date: Wed, 21 Sep 2016 21:52:14 +0300
Subject: [PATCH 8/8] pwcli: cmd_commit(): collect faillog and add it to the
 summary mail

Signed-off-by: Kalle Valo <kvalo@codeaurora.org>
---

Copyright (c) 2016, The Linux Foundation.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 cmdtests/cmd-commit-build-failure.script |   62 +++++++++++++++++
 cmdtests/cmd-commit-build-failure.stdout |  109 ++++++++++++++++++++++++++++++
 pwcli                                    |  104 +++++++++++++++++-----------
 3 files changed, 234 insertions(+), 41 deletions(-)
 create mode 100755 cmdtests/cmd-commit-build-failure.script
 create mode 100644 cmdtests/cmd-commit-build-failure.stdout

diff --git a/cmdtests/cmd-commit-build-failure.script b/cmdtests/cmd-commit-build-failure.script
new file mode 100755
index 000000000000..19a45723e735
--- /dev/null
+++ b/cmdtests/cmd-commit-build-failure.script
@@ -0,0 +1,62 @@
+#!/usr/bin/env python
+#
+# Copyright (c) 2016, The Linux Foundation.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are
+# met:
+#
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# 3. Neither the name of the copyright holder nor the names of its
+# contributors may be used to endorse or promote products derived from
+# this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+import cmdtestlib
+
+def test_commit(ctxt, pwcli):
+   pwcli.expect_prompt()
+   pwcli.sendline('list')
+   pwcli.expect_prompt()
+
+   ctxt.builder.set_warning_count(5)
+   ctxt.builder.set_return_value(1)
+
+   pwcli.sendline('commit 1')
+   pwcli.expect(cmdtestlib.PROMPT_COMMIT_ALL)
+   pwcli.sendline('a')
+   pwcli.expect(cmdtestlib.PROMPT_COMMIT_ACCEPT)
+   pwcli.sendline('c')
+
+   pwcli.expect(cmdtestlib.PROMPT_REVIEW_REASON)
+   pwcli.sendline('Compile errors')
+
+   pwcli.expect(cmdtestlib.PROMPT_REPLY)
+   pwcli.sendline('s')
+
+   pwcli.expect_prompt()
+   pwcli.sendline('quit')
+
+   print ctxt.smtpd.get_mails_as_string()
+
+if __name__ == "__main__":
+   cmdtestlib.StubContext.run_test(test_commit)
diff --git a/cmdtests/cmd-commit-build-failure.stdout b/cmdtests/cmd-commit-build-failure.stdout
new file mode 100644
index 000000000000..26f6d69f03f4
--- /dev/null
+++ b/cmdtests/cmd-commit-build-failure.stdout
@@ -0,0 +1,109 @@
+Connecting to http://localhost:8105/
+User          : test (7477, 30052, 118371)
+Projects      : stub-test
+Tree          : data
+Branch        : test-branch
+New           : 1
+Review        : 2
+Upstream      : 0
+Deferred      : 1
+Total         : 4
+test-branch@data > list
+list
+[  1] 1001 [1/7] foo: test 1
+[  2] 1002 [1/7] foo: test 2
+test-branch@data > commit 1
+commit 1
+Retrieving patches (1/1)
+1001 [1/7] foo: test 1
+------------------------------------------------------------
+1 patches
+commit All/commit Individually/aBort? a
+a
+                                                                   CC foo.c                                                                   CC bar.c                                                                   CC aaa.c                                                                   CC bbb.c                                                                 foo.c: warning: is suspicious
+bar.c: warning: is suspicious
+aaa.c: warning: is suspicious
+bbb.c: warning: is suspicious
+Build failed: 1
+============================================================
+1 patches applied:
+
+fb409caeb2ec foo: test 1
+
+Under review/Changes requested/Rejected/New/Deferred/Superseded/aWaiting upstreamm/not aPplicable/rFc/aBort? c
+c
+Patch set to Changes Requested
+Reason (RET for no mail): Compile errors
+Compile errors
+============================================================
+Content-Type: text/plain; charset="utf-8"
+MIME-Version: 1.0
+Content-Transfer-Encoding: 7bit
+Subject: Re: [1/7] foo: test 1
+From: Timo Testi <test@example.com>
+In-Reply-To: <11111@example.com>
+References: <11111@example.com>
+To: Dino Dinosaurus <dino@example.com>
+
+Dino Dinosaurus <dino@example.com> wrote:
+> 
+> Foo commit log. Ignore this text
+> 
+> Signed-off-by: Dino Dinosaurus <dino@example.com>
+
+Patch set to Changes Requested.
+
+1001 [1/7] foo: test 1
+
+Reason: Compile errors
+
+foo.c: warning: is suspicious
+bar.c: warning: is suspicious
+aaa.c: warning: is suspicious
+bbb.c: warning: is suspicious
+
+-- 
+Sent by pwcli
+http://localhost:8105/1001/
+
+
+============================================================
+Envelope From: Timo Testi <test@example.com>
+Envelope To: ['Dino Dinosaurus <dino@example.com>']
+Send/Edit/aBort? s
+s
+test-branch@data > quit
+mail 0:
+----------------------------------------------------------------------
+test@example.com -> dino@example.com
+Content-Type: text/plain; charset="utf-8"
+MIME-Version: 1.0
+Content-Transfer-Encoding: 7bit
+Subject: Re: [1/7] foo: test 1
+From: Timo Testi <test@example.com>
+In-Reply-To: <11111@example.com>
+References: <11111@example.com>
+To: Dino Dinosaurus <dino@example.com>
+
+Dino Dinosaurus <dino@example.com> wrote:
+> 
+> Foo commit log. Ignore this text
+> 
+> Signed-off-by: Dino Dinosaurus <dino@example.com>
+
+Patch set to Changes Requested.
+
+1001 [1/7] foo: test 1
+
+Reason: Compile errors
+
+foo.c: warning: is suspicious
+bar.c: warning: is suspicious
+aaa.c: warning: is suspicious
+bbb.c: warning: is suspicious
+
+-- 
+Sent by pwcli
+http://localhost:8105/1001/
+----------------------------------------------------------------------
+
diff --git a/pwcli b/pwcli
index 547bcbdb5db4..6c97072d1dbd 100755
--- a/pwcli
+++ b/pwcli
@@ -1014,6 +1014,8 @@ class PWCLI():
       else:
          self.output('Build succesful')
 
+      return p
+
    def get_pending_branch_patches(self):
       patches = []
 
@@ -1157,41 +1159,44 @@ class PWCLI():
          self.git.checkout(self.selected_main_branch)
 
       applied = []
-      for patch in patches:
+      faillog = ''
+      builder = None
 
-         # edit can be chosen multiple times, that's why the loop
-         while commit_individually:
-            # FIXME: in stgit mode we should show the commit log from
-            # pending branch
-            self.show_patch(patch)
+      try:
+         for patch in patches:
 
-            ANSWER_COMMIT = 'Commit'
-            ANSWER_EDIT = 'Edit'
-            ANSWER_ABORT = 'aBort'
+            # edit can be chosen multiple times, that's why the loop
+            while commit_individually:
+               # FIXME: in stgit mode we should show the commit log from
+               # pending branch
+               self.show_patch(patch)
 
-            answer = self.show_choose_list([ANSWER_COMMIT, ANSWER_EDIT, ANSWER_ABORT],
-                                           prefix='[%d/%d] ' % (len(applied) + 1,
-                                                                len(patches)))
+               ANSWER_COMMIT = 'Commit'
+               ANSWER_EDIT = 'Edit'
+               ANSWER_ABORT = 'aBort'
 
-            if answer == ANSWER_ABORT:
-               self.output('Commit command aborted')
-               return
+               answer = self.show_choose_list([ANSWER_COMMIT, ANSWER_EDIT, ANSWER_ABORT],
+                                              prefix='[%d/%d] ' % (len(applied) + 1,
+                                                                   len(patches)))
 
-            if answer == ANSWER_EDIT:
-               mbox = patch.get_mbox()
-               new_mbox = self.edit_file(mbox)
+               if answer == ANSWER_ABORT:
+                  self.output('Commit command aborted')
+                  return
 
-               if mbox != new_mbox:
-                  patch.set_mbox(new_mbox)
+               if answer == ANSWER_EDIT:
+                  mbox = patch.get_mbox()
+                  new_mbox = self.edit_file(mbox)
 
-               continue
+                  if mbox != new_mbox:
+                     patch.set_mbox(new_mbox)
 
-            if answer == ANSWER_COMMIT:
-               # continue with commit process
-               break
+                  continue
 
-         # apply the patch
-         try:
+               if answer == ANSWER_COMMIT:
+                  # continue with commit process
+                  break
+
+            # apply the patch
             if self.pending_mode == 'stgit':
                # FIXME: add sanity check that the patch really is in
                # review state. Also applies to main ('non-pending')
@@ -1214,26 +1219,34 @@ class PWCLI():
 
             applied.append(patch)
 
-         except GitError as e:
-            self.output('Failed to apply the patch: %s' % e)
+      except GitError as e:
+         self.output('Failed to apply the patch: %s' % e)
+         # FIXME: add info to faillog
 
-      # FIXME: should also summary if none of the patches were applied
-      if len(applied) == 0:
-         return
+      if len(applied) == len(patches):
+         # all patches were succesfully applied
 
-      # run a build test
-      self.run_build_script()
+         # run a build test
+         builder = self.run_build_script()
 
-      # show summary in the shell
-      self.output('============================================================')
-      self.output('%d patches applied:' % len(applied))
-      self.output('')
-      self.output(self.git.log_oneline(len(applied)))
-      self.output('')
+         if len(builder.stderrdata) > 0:
+            faillog += builder.stderrdata
+
+         # show summary in the shell
+         self.output('============================================================')
+         self.output('%d patches applied:' % len(applied))
+         self.output('')
+         self.output(self.git.log_oneline(len(applied)))
+         self.output('')
 
       # need to use ordered dict so that the list is shown in correct order
       state_table = collections.OrderedDict()
-      state_table['Accepted'] =           PATCH_STATE_ACCEPTED
+
+      # Accepted state should not be shown if any of the patches
+      # failed apply or the build failed
+      if (len(patches) == len(applied)) and (builder and builder.returncode == 0):
+         state_table['Accepted'] =           PATCH_STATE_ACCEPTED
+
       state_table['Under review'] =       PATCH_STATE_UNDER_REVIEW
       state_table['Changes requested'] =  PATCH_STATE_CHANGES_REQUESTED
       state_table['Rejected'] =           PATCH_STATE_REJECTED
@@ -1247,6 +1260,11 @@ class PWCLI():
 
       state = self.show_choose_list(state_table)
 
+      if state != PATCH_STATE_ACCEPTED:
+         # FIXME: git revert all patches in applied list as the user
+         # didn't accept them
+         pass
+
       if state == STATE_ABORTED:
          self.output('Aborted.')
          return
@@ -1277,6 +1295,9 @@ class PWCLI():
                                                    branch_name,
                                                    tree_name)
          reply += '%s\n\n' % self.git.log_oneline(len(patches))
+
+         # Note: faillog is not added if the patches are accepted, for
+         # example no need to show false warnings
       else:
          reason = self.input('Reason (RET for no mail): ')
          reason = reason.strip()
@@ -1292,7 +1313,8 @@ class PWCLI():
          reason = textwrap.fill(reason, MAIL_BODY_WIDTH)
          reply += 'Reason: %s\n\n' % (reason)
 
-         # FIXME: add possible git failures and build logs
+         # add possible git and build failures/warnings to the mail
+         reply += '%s\n' % (faillog)
          
       first_patch = patches[0]
       msg = first_patch.get_reply_msg(self.fullname, self.email,
-- 
1.7.9.5

